%global gem_name  ffi
%global _version  1.4.0

%if 0%{?rhel} == 5
%global gem_dir         %(ruby -rubygems -e 'puts Gem::dir' 2>/dev/null)
%global gem_instdir     %{gem_dir}/gems/%{gem_name}-%{version}
%global gem_libdir      %{gem_instdir}/lib
%global gem_cache       %{gem_dir}/cache/%{gem_name}-%{version}.gem
%global gem_spec        %{gem_dir}/specifications/%{gem_name}-%{version}.gemspec
%global gem_docdir      %{gem_dir}/doc/%{gem_name}-%{version}
%global gem_extdir_mri  %(ruby -rrbconfig -e 'puts RbConfig::CONFIG["sitearchdir"] ')
%else
%{!?gem_extdir_mri:     %global gem_extdir_mri  %(ruby -rrbconfig -e 'puts RbConfig::CONFIG["sitearchdir"] ')}
%endif

%if 0%{?rhel} >= 7
%global compiled_libs_dir %{gem_extdir_mri}/lib
%else
%global compiled_libs_dir %{gem_extdir_mri}
%endif


Name:           rubygem-%{gem_name}
Version:        %{_version}
Release:        1%{?dist}
Summary:        FFI Extensions for Ruby
Group:          Development/Languages

License:        LGPLv3
URL:            http://rubygems.org/gems/%{gem_name}
Source0:        http://rubygems.org/downloads/%{gem_name}-%{version}.gem

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  ruby
BuildRequires:  ruby-devel
BuildRequires:  libffi-devel
BuildRequires:  rubygem-rake
BuildRequires:  rubygem-rake-compiler
BuildRequires:  pkgconfig
%if 0%{?rhel} == 5
BuildRequires:  rubygems
Requires:       ruby(abi) >= 1.8
Requires:       ruby(rubygems)
Provides:       rubygem(%{gem_name}) = %{version}
%else
BuildRequires:  rubygems-devel
Requires:       ruby
Requires:       rubygems
%endif
Requires:       libffi

%description
Ruby-FFI is a ruby extension for programmatically loading dynamic
libraries, binding functions within them, and calling those functions
from Ruby code. Moreover, a Ruby-FFI extension works without changes
on Ruby and JRuby. Discover why should you write your next extension
using Ruby-FFI here[http://wiki.github.com/ffi/ffi/why-use-ffi].

%prep
gem unpack %{SOURCE0}
%setup -q -D -T -n  %{gem_name}-%{version}
gem spec %{SOURCE0} -l --ruby > %{gem_name}.gemspec


%build
export CFLAGS="%{optflags}"
export CONFIGURE_ARGS="--with-cflags='%{optflags}'"
mkdir -p .%{gem_dir}
gem build %{gem_name}.gemspec
gem install --verbose --local --no-ri --install-dir .%{gem_dir} --force %{SOURCE0}


%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{gem_dir}
mkdir -p %{buildroot}%{compiled_libs_dir}
mkdir -p %{buildroot}%{gem_docdir}

cp -a .%{gem_dir}/* %{buildroot}%{gem_dir}/
mv %{buildroot}%{gem_instdir}/lib/%{gem_name}_c.so %{buildroot}%{compiled_libs_dir}/
rm -r %{buildroot}%{gem_instdir}/ext


%clean
rm -rf %{buildroot}


%files
%defattr(-,root,root,-)
%dir %{gem_instdir}
%{gem_docdir}
%{gem_instdir}/Rakefile
%{gem_libdir}
%{gem_instdir}
%{compiled_libs_dir}/ffi_c.so
%{gem_cache}
%{gem_spec}


%changelog
* Tue Nov 18 2014 Melissa Stone <melissa@puppetlabs.com> - 1.4.0-1
- Update to upstream version 1.4.0

* Wed Jul 02 2014 Eric Timmerman <eric.timmerman@puppetlabs.com> - 1.0.9-12
- Update ruby requires to allow build for RHEL 7

* Mon Apr 07 2014 Melissa Stone <melissa@puppetlabs.com> - 1.0.9-11
- (CPR-26) install ffi_c.so into correct libdir so gem can be used

* Thu Jun 27 2013 Michael Stahnke <stahnma@puppetlabs.com> - 1.0.9-10
- Rebuilding due to ruby rebuild

* Tue Apr 09 2013 Matthaus Owens <matthaus@puppetlabs.com> - 1.0.9-9
- Rebuilt for Puppet Labs dependencies repos. Bump release to eclipse epel :)

* Tue Feb 26 2013 Matthaus Owens <matthaus@puppetlabs.com> - 1.0.9-6
- Rebuilt for Puppet Labs dependencies repos. Updated to build for el5,el6,f16,f17,f18

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.9-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Thu Feb 02 2012 Vít Ondruch <vondruch@redhat.com> - 1.0.9-4
- Rebuilt for Ruby 1.9.3.

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.9-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Tue Jun 14 2011 Bryan Kearney <bkearney@redhat.com> - 1.0.9-2
- Fixed the License, it is actually LGPL

* Mon Jun 13 2011 Bryan Kearney <bkearney@redhat.com> - 1.0.9-1
- Bring in 1.0.9 from upstream.

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.6.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Mar 10 2010 Bryan Kearney <bkearney@redhat.com> - 0.6.2-1
- Power PC fixes from upstream which were found testing 0.6.2

* Tue Feb 22 2010 Bryan Kearney <bkearney@redhat.com> - 0.6.2-1
- Pull in 0.6.2 from upstream

* Tue Feb 22 2010 Bryan Kearney <bkearney@redhat.com> - 0.5.4-3
- Final updates based on package review

* Tue Feb 16 2010 Bryan Kearney <bkearney@redhat.com> - 0.5.4-2
- Updates Based on code review comments

* Mon Feb 15 2010 Bryan Kearney <bkearney@redhat.com> - 0.5.4-1
- Initial specfile
